%Define initial values if available or by reading from file
useInitial = 1;
readFromFile = 0;
swarm_size = 6;
if readFromFile == 1
    readLoggingFile;
else
    x_initial = x_l;
    v_initial = [rand([3,swarm_size])*(2*(1.5 - 0.7)) - (1.5 - 0.7);rand([3,swarm_size])*(2*(0.50 - 0.1)) - (0.5-0.1)];
    f_l_initial = zeros(1,swarm_size);
    x_l_initial = x_l;
    f_g_initial = 0;
    g_initial = zeros(6,1);
end

    

%Ref_filter
w_d = diag([0.1 0.1 0.1]);
zeta = diag([1 1 1]);
v_max = 0.1;
%Simulation time
t_sim = 180;
%Scaling factor
gamma = 90;
%Load RAO needed for calculating wave forces
%load('CSAD_model.mat')
%Set wave parameters
Hs = 2.5/gamma*10^-100;
omega_p = 0.68*sqrt(gamma)*10^-100;
% wave_dir = pi/2;%Eastgoing waves
%Initialize reference filter
% omega = diag([0.11,0.11]);
% zeta = diag([1,1]);
% U_max = 0.07;
% r_max = 3*pi/180;
% d_r_max = 0.6*pi/180;
%Initialize wave filtering parameters
lambda = diag([0.1 0.1 0.1]);
w_o = diag([omega_p omega_p omega_p]);
T_b = diag([100 100 100])/sqrt(gamma);
w_c = diag([omega_p omega_p omega_p])*1.2255;
K2 = w_c;
K3 = diag([0.1,0.1,0.01]);
K4 = diag([1,1,0.1]);
%Initialize current

nu_c_NED = [0,0,0]';
%Initialising matrices

X_u		= -5.35;		
X_uu 	=  0;		
X_uuu	= -19.6312;

Y_v		= -10.16;   
Y_vv	= -0.8647;
Y_vvv	= -681.1745;	

Y_r		= -7.25;
Y_rr	= -3.45;
Y_rrr   = 0;

N_v		= 0;		
N_vv	= -0.2088;
N_vvv = 0;

N_r		= -14.55;
N_rr	= -9.9597;
N_rrr	= -0.3101;

N_rv	= 0.08;	
N_vr	= 0.08;
Y_rv	= -0.805;			
Y_vr	= -0.845;

X_ud =     -10;
Y_vd =     -105;
Y_rd =     -0.525;
N_vd =     -0.157;	
N_rd =     -3.4950;

Nur  = Y_rd;
Nuv  = -(Y_vd-X_ud);
Yur  = X_ud;

x_g     = 0.0375;
m       = 127.92;
I_z     = 61.967;

u   = 0;
v   = 0;
r   = 0;

d_11 = - X_u - X_uu*abs(u) - X_uuu*u^2;
d_22 = - Y_v - Y_vv*abs(v) - Y_rv*abs(r) - Y_vvv*v^2;
d_23 = - Y_r - Y_rr*abs(r) - Y_vr*abs(v) - Y_rrr*r^2 - Yur*u;
d_32 = - N_v - N_vv*abs(v) - N_rv*abs(r) - N_vvv*v^2 - Nuv*u;
d_33 = - N_r - N_rr*abs(r) - N_vr*abs(v) - N_rrr*r^2 - Nur*u;

D    = [d_11  0     0
        0     d_22  d_23
        0     d_32  d_33];

CA=[0                            0          Y_vd*v+Y_rd*r;
    0                            0                -X_ud*u;
    -Y_rd*r-Y_vd*v               X_ud*u                0];

CRB=[0             0     -m*(x_g*r+v);
     0             0      m*u;
     m*(x_g*r+v) -m*u     0]; 

C=CRB+CA;

M_RB_c=[m     0      0;
        0     m      m*x_g;
        0     m*x_g  I_z];

M_A_c=[-X_ud    0      0;
         0    -Y_vd  -Y_rd;
         0    -N_vd  -N_rd];     
    
M = M_RB_c + M_A_c;

Lx1 =  1.0678;   Ly1 =  0.0;
Lx2 =  0.9344;   Ly2 =  0.11;
Lx3 =  0.9344;   Ly3 = -0.11;
Lx4 = -1.1644;   Ly4 =  0.0;
Lx5 = -0.9911;   Ly5 = -0.1644;
Lx6 = -0.9911;   Ly6 =  0.1644;

K_e1 = 1.491*diag([1,1,1,1,1,1]);
alpha = [pi pi/4 -pi/4 0 5*pi/4 3*pi/4]';
L = [Lx1 norm([Lx2 Ly2]) norm([Lx3 Ly3]) norm([Lx4 Ly4]) norm([Lx5 Ly5]) norm([Lx6 Ly6])];
v1 = [0 atan(Ly2/Lx2) atan(Ly3/Lx3) 0 atan(Ly5/Lx5) atan(Ly6/Lx6)];

T_m = [cos(alpha)'; sin(alpha)'; cos(v1).*sin(alpha)'.*L];
T_m(3,5)=-T_m(3,5);
T_m(3,6)=-T_m(3,6);

T = T_m*K_e1;
%nedskalering av sway force og yaw moment
%slik at det passer med hva som er mlt i lab
%(dette m simuleres for alle u for  gi mening)
T(2,2) = 0.95*T(2,2);
T(2,3) = 0.95*T(2,3);
T(2,5) = 0.95*T(2,5);
T(2,6) = 0.95*T(2,6);
T(3,2) = 0.85*T(2,2);
T(3,3) = 0.85*T(2,3);
T(3,5) = -0.85*T(2,5);
T(3,6) = -0.85*T(2,6);

T_pinv_m = pinv(T);
eta_initial = [0,0,0]';
nu_initial  = [0,0,0]';