



%%Setting the axis
factor  = 70;

x_limits = [-2 7];
y_limits = [-3 3];
z_limits = [-2 2];

myaxes = axes('xlim',x_limits,'ylim',y_limits ,'zlim',z_limits );
view(3)
grid on
axis equal 
hold on

xlabel('North, x')
ylabel('East, y')
zlabel('Down')

%% Generate some objects
r = 0.22/2.578;
[xcylinder ycylinder zcylinder] = cylinder([r r]);
[x,y,z] = sphere;

set(gca, 'YDir','reverse')
%% Plot different orientations of these
% Actual trajectory
h(1) = surface(0.1+zcylinder*0.8 - 0.5,xcylinder, ycylinder, 'FaceColor','y','LineStyle','none');
h(2:7) = makeCube([0-0.5,0.9-r-0.5], [-r,r], [0,r],'y', 1, 'none' );
h(8:13) = makeCube([0.1-0.5,0.4-0.5], [-r ,r]*0.8, [r,r *2],'w', 1, '-' );
h(14) = surface(x*r+1-r -0.5, y*r, z*r, 'FaceColor','y','LineStyle','none');

% Desired trajectory
% h2(1) = surface(zcylinder,xcylinder, ycylinder, 'FaceColor','r', 'LineStyle','none');
% h2(2:7) = makeCube([0,0.9], [-0.22/2.578,0.22/2.578], [0,0.22/2.578],'r', 1, 'none' );

% Watertank
water = makeCube(x_limits, y_limits, [z_limits(1) 0],'b' ,0.5, '-');
%Trajectory
traj = makeCube([eta_d(1,1) eta_d(round(size(eta_d,1)/2),1)], [-0.05 0.05], [0 0.5],'r' ,0.5, '-');

%% Create group objects and parent surfaces
% Actual trajectory
combinedobject = hgtransform('parent', myaxes);
set(h, 'parent', combinedobject)
drawnow
% Desired trajectory
% combinedobject2 = hgtransform('parent', myaxes);
% set(h2, 'parent', combinedobject2)
% drawnow




% Watertank
combinedobject3 = hgtransform('parent', myaxes);
set(water, 'parent', combinedobject3)
drawnow
% traj
combinedobject4 = hgtransform('parent', myaxes);
set(traj, 'parent', combinedobject4)
drawnow
%% Motion coordinates
latitude_d = eta_d(:,1);
longitude_d = eta_d(:,2);
altitude_d = zeros(length(latitude_d));
yaw_d = eta_d(:,3);

latitude = eta_hat(:,1);
longitude = eta_hat(:,2);
altitude = zeros(length(latitude));
yaw = eta_hat(:,3);
view(90,90)
%% Animate
title('Position 2','interpreter','latex', 'FontSize',13)
for i = 1:90
    translation = makehgtform('translate', [latitude(i) longitude(i) altitude(i)]);
    %set(combinedobject,'matrix', translation)
    
    rotation3 = makehgtform('zrotate', yaw(i));
    %set(combinedobject,'matrix', rotation3)
    
    scaling = makehgtform('scale', 2.578);
    set(combinedobject,'matrix', translation*rotation3*scaling)
    
%     translation = makehgtform('translate', [latitude_d(i) longitude_d(i) altitude_d(i)]);
%     %set(combinedobject,'matrix', translation)
%     
%     rotation3 = makehgtform('zrotate', yaw_d(i));
%     %set(combinedobject,'matrix', rotation3)
%     
%     scaling = makehgtform('scale', 25.78*2);
%     set(combinedobject2,'matrix', translation*rotation3*scaling)
    time_scale = 20;
    pause(1/time_scale)
    
end
hold off
