function [cost_IAE, cost_IAEW, cost_tau] = calc_cost(error,nu,tau, PI)
% eta_d = reshape(eta_d,[3,length(t)]);
% eta_d = eta_d';
% 
% tau = reshape(tau,[3,length(t)]);
% tau = tau';
max_err_pos = 2;
max_err_psi = pi/2;
max_tau_surge = 3.6;%N
max_tau_sway = 2;%N
max_tau_yaw = 1.7;%N
max_nu_surge = 0.4142;%N
max_nu_sway = 0.109;%N
max_nu_yaw = 6.327*pi/180;%



error_norm = [abs(error(:,1)./max_err_pos) abs(error(:,2)./max_err_pos) abs(error(:,3) ./ max_err_psi)];
tau_norm = [abs(tau(:,1)./max_tau_surge) abs(tau(:,2)./max_tau_sway) abs(tau(:,3) ./ max_tau_yaw)];
nu_norm = [abs(nu(:,1)./max_nu_surge) abs(nu(:,2)./max_nu_sway) abs(nu(:,3) ./ max_nu_yaw)];

lambda = 90;

err = sum(error_norm(:,1)+error_norm(:,2)+error_norm(:,3))*0.01;
tau_tot = sum(tau_norm(:,1)+tau_norm(:,2)+tau_norm(:,3))*0.01;

P_u = abs(nu_norm(:,1))'*abs(tau_norm(:,1))*0.01;
P_v = abs(nu_norm(:,2))'*abs(tau_norm(:,2))*0.01;
P_psi = abs(nu_norm(:,3))'*abs(tau_norm(:,3))*0.01;

P = P_u +P_v + P_psi;


cost_IAE = err;

cost_IAEW = err*P;

cost_tau = tau_tot;



