
function [cost] = f(x) 

zeta = diag(x(1:3));

omega_b = diag(x(4:6));
eta_initial = [3,0,-pi/4]';
% set_param('model_for_simulation/Constant2', 'Value', mat2str(eta_initial));
set_param('model_for_simulation/Simulation inputs/const1', 'Value', mat2str(zeta));
set_param('model_for_simulation/Simulation inputs/const2', 'Value', mat2str(omega_b));

simout = sim('model_for_simulation'); 

eta_d = eta_d.Data;
nu_d = nu_d.Data;
eta_m = eta_m.Data;
eta = eta_hat.Data;
eta_e = eta_d - eta;
nu2 = nu.Data;
nu = nu_hat.Data;
tau = tau.Data;


[cost_IAE, cost_IAEW, cost_tau] = calc_cost(eta_e,nu,tau, 1);
cost_IAEC = cost_IAE + 0.15*cost_tau;
cost = cost_IAE;


fileID = fopen('IAE_FINAL.txt','a');

fprintf(fileID,'%f %f %f %f %f %f %f %f %f\n',x', cost_IAE, cost_IAEW, cost_IAEC);

fclose(fileID);
% figure(1)
% subplot(3,1,1);
% x = 0.01*(1:length(eta_d));
% y11 = eta(:,1);
% y12 = eta_d(:,1);
% plot(x,y11,x,y12)
% xlim([20 200])
% ylim([2.5 5.5])
% legend('$\hat{x}\;[m]$', '$x_{d}\;[m]$','interpreter','latex')
% subplot(3,1,2); 
% y21 = eta(:,2);
% y22 = eta_d(:,2);
% plot(x,y21,x,y22)
% xlim([20 200])
% ylim([-2 2])
% legend('$\hat{y}\;[m]$','$y_{d}\;[m]$','interpreter','latex')
% 
% subplot(3,1,3); 
% y31 = eta(:,3)*180/pi;
% y32 = eta_d(:,3)*180/pi;
% plot(x,y31,x,y32)
% xlim([20 200])
% ylim([-200 0])
% legend('$\hat{\psi}\;[deg]$','$\psi_{d}\;[deg]$','interpreter','latex')
% xlabel('$Time\;[s]$','interpreter','latex');
% figure(2)
% subplot(3,1,1);
% x = 0.01*(1:length(eta_d));
% y11 = eta(:,1)-eta_d(:,1);
% plot(x,y11)
% xlim([20 200])
% ylim([-0.05 0.05])
% legend('$\eta_{e,E}\; [m]$','interpreter','latex')
% subplot(3,1,2); 
% y21 = eta(:,2) - eta_d(:,2);
% plot(x,y21)
% xlim([20 200])
% ylim([-0.05 0.05])
% legend('$\eta_{e,E}\; [m]$','interpreter','latex')
% 
% subplot(3,1,3); 
% y31 = eta(:,3)*180/pi - eta_d(:,3)*180/pi;
% plot(x,y31)
% xlim([20 200])
% ylim([-1 1])
% legend('$\eta_{e,\psi}\; [deg]$','interpreter','latex')
% 
% xlabel('$Time\;[s]$','interpreter','latex');
% figure(3)
% subplot(3,1,1);
% x = 0.01*(1:length(eta_d));
% y11 = tau(:,1);
% plot(x,y11)
% xlim([20 200])
% ylim([-3.6 3.6])
% legend('$\tau_{u}\;[N]$','interpreter','latex')
% 
% subplot(3,1,2); 
% y21 = tau(:,2);
% plot(x,y21)
% xlim([20 200])
% ylim([-2 2])
% legend('$\tau_{v}\;[N]$','interpreter','latex')
% 
% subplot(3,1,3); 
% y31 = tau(:,3);
% plot(x,y31)
% xlim([20 200])
% ylim([-1.7 1.7])
% legend('$\tau_{r}\;[Nm]$','interpreter','latex')
% 
% 
% xlabel('$Time\;[s]$','interpreter','latex');
% figure(4)
% subplot(3,1,1);
% x = 0.01*(1:length(eta_d));
% y11 = nu(:,1);
% y12 = nu_d(:,1);
% plot(x,y11,x,y12)
% xlim([20 200])
% ylim([-0.1 0.1])
% legend('$\hat{u}\;[m/s]$', '$u_{d}\;[m/s]$','interpreter','latex')
% 
% subplot(3,1,2);
% y21 = nu(:,2);
% y22 = nu_d(:,2);
% plot(x,y21,x,y22)
% xlim([20 200])
% ylim([-0.1 0.1])
% legend('$\hat{v}\;[m/s]$','$v_{d}\;[m/s]$','interpreter','latex')
% 
% subplot(3,1,3); 
% y31 = nu(:,3)*180/pi;
% y32 = nu_d(:,3)*180/pi;
% plot(x,y31,x,y32)
% xlim([20 200])
% ylim([-3 3])
% legend('$\hat{r}\;[deg/s]$','$r_{d}\;[deg/s]$','interpreter','latex')
% xlabel('$Time\;[s]$','interpreter','latex');
% end

